{*******************************************************}
{                                                       }
{       ֮ HappyViewer  (UFO ļ)      }
{                                                       }
{       Copyright (c) 1999  HappyBird             }
{                                                       }
{*******************************************************}
unit UnitConvert;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FileCtrl, StdCtrls, Buttons, Menus, ComCtrls;

const
  Buffer: array[0..9] of Char = (#$FF, #$D8, #$FF, #$E0, #$0, #$10, #$4A, #$46, #$49, #$46);

type
  TFormConvert = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    DriveComboBox2: TDriveComboBox;
    DirectoryListBox2: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    GroupBox3: TGroupBox;
    FileListBox1: TFileListBox;
    GroupBox4: TGroupBox;
    ListBox1: TListBox;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    ProgressBar1: TProgressBar;
    procedure BitBtn1Click(Sender: TObject);
    procedure mnuChangeClick(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure FileListBox1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormConvert: TFormConvert;

implementation


{$R *.DFM}

function SlashSep(const Path, S: string): string;
begin
  if AnsiLastChar(Path)^ <> '\' then
    Result := Path + '\' + S
  else
    Result := Path + S;
end;

procedure TFormConvert.BitBtn1Click(Sender: TObject);
var
  i: integer;
  S, S2: string;
  M: TMemoryStream;
begin
  if ListBox1.Items.Count = 0 then
  begin
    Application.MessageBox('ѡҪתļ', '', MB_OK);
    exit;
  end;
  BitBtn1.Visible := False;
  BitBtn2.Visible := False;
  ProgressBar1.Visible := True;
  ProgressBar1.Min := 0;
  ProgressBar1.Max := ListBox1.Items.Count - 1;
  M := TmemoryStream.Create;
  try
    for i := 0 to (ListBox1.Items.Count - 1) do
    begin
      ProgressBar1.Position := i;
      S := SlashSep(DirectoryListBox1.Directory, Listbox1.items.strings[i]);
      S2 := Listbox1.items.strings[i];
      S2 := Copy(S2, 1, Length(S2) - 3) + 'jpg';
      S2 := SlashSep(DirectoryListBox2.Directory, S2);
      M.LoadFromFile(S);
      M.WriteBuffer(Buffer, 10);
      M.Seek(0, soFromBeginning);
      M.SaveToFile(S2);
    end;
  finally
    M.Destroy;
    BitBtn1.Visible := True;
    BitBtn2.Visible := True;
    ProgressBar1.Visible := False;
  end;
  Application.MessageBox(pchar(IntToStr(ListBox1.Items.Count) + 'ļתɹ'), 'ɹ', MB_OK);
end;

procedure TFormConvert.mnuChangeClick(Sender: TObject);
begin
  bitbtn1.Click;
end;

procedure TFormConvert.DirectoryListBox1Change(Sender: TObject);
begin
  ListBox1.Clear;
  Label2.Caption := 'ļ 0';
  FileListBox1.Directory := DirectoryListBox1.Directory;
end;

procedure TFormConvert.BitBtn3Click(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to (FileListBox1.Items.Count - 1) do
  begin
    if FileListBox1.Selected[i] then
      if ListBox1.Items.IndexOf(FileListBox1.Items.Strings[i]) = -1 then
        ListBox1.Items.Add(FileListBox1.Items.Strings[i]);
  end;
  Label2.Caption := 'ļ ' + inttostr(ListBox1.Items.Count);
end;

procedure TFormConvert.BitBtn5Click(Sender: TObject);
var
  i: integer;
begin
  for i := (ListBox1.Items.Count - 1) downto 0 do
    if ListBox1.Selected[i] then
      ListBox1.Items.Delete(i);
  Label2.Caption := 'ļ ' + inttostr(ListBox1.Items.Count);
end;

procedure TFormConvert.BitBtn4Click(Sender: TObject);
var
  i: integer;
begin
  ListBox1.Clear;
  for i := 0 to (FileListBox1.Items.Count - 1) do
  begin
    ListBox1.Items.Add(FileListBox1.Items.Strings[i]);
  end;
  Label2.Caption := 'ļ ' + inttostr(ListBox1.Items.Count);
end;

procedure TFormConvert.FileListBox1Change(Sender: TObject);
begin
  Label1.Caption := 'ļ ' + inttostr(FileListBox1.Items.Count);
end;

end.
